/*

 B A B I Z E S - kontrola napajeni a on/off logika
 
 Ivo Strasil (c) 2005
 
 ------------------------------------------

 PIC12F675

*/
//pripojeni knihoven
#include <pic.h>
#include "delay.h"

#define PORTBIT(adr,bit)	((unsigned)(&adr)*8+(bit))

static bit	TXD    @ PORTBIT(GPIO,0);	

unsigned short adc_read(unsigned char channel)
{

		ADCON0 = (channel << 2) + 0x81;		// enable ADC, RC osc.
		DelayUs(20);
		GODONE = 1;
		while(GODONE)
			{NOP();};	// wait for conversion complete
		return ADRESH*256+ADRESL;	
}

void Delay(unsigned char dcnt) {
	//pro xtal 4MHzm, v dcnt je delka cekani x 20us
	while (--dcnt != 0) {
		DelayUs(15);
	}
}

//cas bitu v us
#define	bittime	90

void Smrt() {
			while (1) {
 			 DelayMs(40);
 			 GPIO=0;
 			 DelayMs(40);
 			 GPIO=2;
			};
}	

void main() {
	//promenne hlavni smycky

	unsigned short adout,i;
        unsigned long napeti;
        unsigned long cekacka=0;
        unsigned int castl=0;
	
	//nastaveni I/O portu
	GPIO=4;
	WPU=0x30;			
	TRISIO=1+8;
	//nastaveni procesoru
	OPTION=0x0F;
	//nastaveni AD prevodniku a jeho zapnuti
	ADCON0=1;
	ANSEL=0x31;
	CMCON=0x07;
	//pockame chvilku
	DelayMs(100);
	//zhasneme LED
	GPIO=4+2;
	
	while (1) {
		TMR1L=0;
		TMR1H=0;
                //AD prevod
		adout=adc_read(0);
                napeti=(unsigned long)adout*50*100/1023;
                //na vstupu je 1,95 V
                //hranicni napeti:
                //varovani pred vybitim:
                //3,5 V
                //tj. adout>=570
                //vypnuti
                //3,3 V
                //tj. adout>=605
                if (adout>=605) {
	                Smrt();
                }
                
                
                //cekani na 1s
                for (i=0;i<100;i++) {
	                DelayMs(8);
	                //kratky stisk tlacitka nuluje cekacku
	                //dlouhy vypina pristroj
	                if (!(GPIO&8)) {
		          cekacka=0;
		          castl++;
		          GPIO=4;      
		          if (castl>200) {
			          Smrt();
		          }
	                } else {
		          castl=0;
		          GPIO=2+4;      
	                }
	               
	                //varovani pri nizkem napeti - kratke blikani
	                if (adout>=570&&i<10) {
		                GPIO=4;
	                }
	                DelayMs(2);
	                //varovani pri vysoke cekacce - poslednich 10min
	                if (cekacka>3000&&i>50) {
		                GPIO=4;
	                }
                }
		CLRWDT();		
		cekacka++;
		//vyhodnotime vypnuti 
		if (cekacka>3600) {
			GPIO=2;
			Smrt();
		}
	}
}
